/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <paum1202@usherbrooke.ca> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return. -violette paulin 
 * ----------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define MOD2POW63(n) ((n) % UINT64_MAX)

#define SIZE_KEY 32

static inline uint32_t	gen();
static inline uint32_t	E1(char, uint32_t, uint32_t);
static inline uint32_t	D1(char, uint32_t, uint32_t);

static inline uint32_t	Sign2(char, uint32_t, uint32_t);
static inline uint32_t	Verif2(char, uint32_t, uint32_t);

static inline uint64_t	ipow(uint32_t, uint32_t);
static inline uint64_t	ipow_mod(uint32_t, uint32_t, uint32_t);

int
main(int argc, char *argv[])
{
	srand(time(0)); /* init rand */

#ifdef PART_1
	uint32_t key_alice  = gen();
	uint32_t key_bob	= gen();

	uint64_t h_a = MOD2POW63(ipow(3, key_alice));
	uint64_t h_b = MOD2POW63(ipow(3, key_bob));

	printf("Alice generated key %d, sent h_a=%lu\n", key_alice, h_a);
	printf("Bob generated key %d, sent h_b=%lu\n", key_bob,	 h_b);


#ifdef EVE_INTERCEPT
	printf("Eve intercepted h_b and h_a.\n");

	uint32_t key_eve = gen();
	uint64_t h_e = MOD2POW63(ipow(3, key_eve));

	printf("Eve generated key %d. She sends h_a to Bob, and h_b to Alice.\n",
			key_eve);

	uint64_t k_e_a = MOD2POW63(ipow(h_a, key_eve));
	uint64_t k_e_b = MOD2POW63(ipow(h_b, key_eve));

	printf("Eve comptued k_e_a=%lu, k_e_b=%lu\n", k_e_a, k_e_b);
	printf("Eve sends h_e_b to Bob and h_e_a to Alice\n");

	h_a = h_e;
	h_b = h_e;
#endif

	uint64_t k_a = MOD2POW63(ipow(h_b, key_alice));
	uint64_t k_b = MOD2POW63(ipow(h_a, key_bob));

	printf("Alice computed k_a=%lu\n", k_a);
	printf("Bob computed k_b=%lu\n",   k_b);

#ifdef EVE_INTERCEPT
	if (k_e_a != k_a) {
		printf("k_e_a != k_a\n");
		exit(-1);
	}
	else if (k_e_b != k_b) {
		printf("k_e_b != k_b\n");
		exit(-1);
	}
	else {
		printf("Bob and Alice keys match with Eve's!\n");
	}

#else
	if (k_a != k_b) {
		printf("k_a != k_b\n");
		exit(-1);
	}
	else {
		printf("Bob and Alice key match\n");
	}

#endif
#endif

#ifdef PART_2
	uint32_t p = 13;
	uint32_t q = 11;
	uint32_t n = p * q;
	uint32_t e = 7;

	uint32_t d = 103; /* as computed in last weeks' assignement, 
						 cant be bothered to implement modular invert rn,
						 im doing this whole assignement w/ only 2 hours :)
						 who tf gives assignement during breaks ?? 
						 therefore i forgor */

	uint32_t e1 = E1(atoi(argv[1]), e, n);
	uint32_t d1 = D1(e1,			d, n);

	printf("m: %d, cypher: %u, decrypt: %u\n", atoi(argv[1]), e1, d1);

#endif

#ifdef PART_3
	uint32_t p = 13;
	uint32_t q = 11;
	uint32_t n = p * q;
	uint32_t e = 7;

	uint32_t d = 103; /* same thing but we reverse priv and pub key 
						 and give it shinny new name so you think it's different
						 :) */
	uint32_t signature = Sign2(atoi(argv[1]), d, n);
	uint32_t verif	   = Verif2(signature, 	  e, n);

	printf("m: %d, signature: %u, verif: %u\n", atoi(argv[1]), signature, verif);


#endif
	return 0;
}

static inline uint32_t
gen()
{
	/* rand is between 0 and UINT32_MAX - 1 / 2 (because sign) */
	return rand() + rand() + (rand() % 1);
}

static uint64_t
ipow(uint32_t base, uint32_t exp)
{
    int result = 1;
    for (;;)
    {
        if (exp & 1)
            result *= base;
        exp >>= 1;
        if (!exp)
            break;
        base *= base;
    }

    return result;
}

static uint64_t
ipow_mod(uint32_t base, uint32_t exponent, uint32_t mod) {
  uint64_t x = 1;
  uint64_t y = base;

  while (exponent > 0) {
    if (exponent % 2 == 1)
      x = (x * y) % mod;
    y = (y * y) % mod;
    exponent = exponent / 2;
  }

  return (x % mod);
}

static uint32_t
E1(char message, uint32_t key_priv, uint32_t n){
	return ipow_mod(message, key_priv, n);
}

static uint32_t
D1(char cypher, uint32_t key_pub, uint32_t n){
	return ipow_mod(cypher, key_pub, n);
}

inline static uint32_t
Sign2(char message, uint32_t key_priv, uint32_t n){
	return E1(message, key_priv, n);
}

inline static uint32_t
Verif2(char signature, uint32_t key_pub, uint32_t n){
	return D1(signature, key_pub, n);
}
